// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: reward.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Reward {
  public static partial class RewardService
  {
    static readonly string __ServiceName = "reward.RewardService";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Battle.Battle> __Marshaller_battle_Battle = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.Battle.Parser));
    static readonly grpc::Marshaller<global::Reward.Reward> __Marshaller_reward_Reward = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Reward.Reward.Parser));
    static readonly grpc::Marshaller<global::Common.RewardId> __Marshaller_common_RewardId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.RewardId.Parser));
    static readonly grpc::Marshaller<global::Common.ResponseStatus> __Marshaller_common_ResponseStatus = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.ResponseStatus.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Reward.RewardList> __Marshaller_reward_RewardList = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Reward.RewardList.Parser));

    static readonly grpc::Method<global::Battle.Battle, global::Reward.Reward> __Method_CreateReward = new grpc::Method<global::Battle.Battle, global::Reward.Reward>(
        grpc::MethodType.Unary,
        __ServiceName,
        "CreateReward",
        __Marshaller_battle_Battle,
        __Marshaller_reward_Reward);

    static readonly grpc::Method<global::Common.RewardId, global::Reward.Reward> __Method_getReward = new grpc::Method<global::Common.RewardId, global::Reward.Reward>(
        grpc::MethodType.Unary,
        __ServiceName,
        "getReward",
        __Marshaller_common_RewardId,
        __Marshaller_reward_Reward);

    static readonly grpc::Method<global::Common.RewardId, global::Common.ResponseStatus> __Method_collectReward = new grpc::Method<global::Common.RewardId, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "collectReward",
        __Marshaller_common_RewardId,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Common.UserId, global::Reward.RewardList> __Method_getAllRewardsByUser = new grpc::Method<global::Common.UserId, global::Reward.RewardList>(
        grpc::MethodType.Unary,
        __ServiceName,
        "getAllRewardsByUser",
        __Marshaller_common_UserId,
        __Marshaller_reward_RewardList);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Reward.RewardReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of RewardService</summary>
    [grpc::BindServiceMethod(typeof(RewardService), "BindService")]
    public abstract partial class RewardServiceBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Reward.Reward> CreateReward(global::Battle.Battle request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Reward.Reward> getReward(global::Common.RewardId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> collectReward(global::Common.RewardId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Reward.RewardList> getAllRewardsByUser(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for RewardService</summary>
    public partial class RewardServiceClient : grpc::ClientBase<RewardServiceClient>
    {
      /// <summary>Creates a new client for RewardService</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public RewardServiceClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for RewardService that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public RewardServiceClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected RewardServiceClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected RewardServiceClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Reward.Reward CreateReward(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CreateReward(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Reward.Reward CreateReward(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_CreateReward, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.Reward> CreateRewardAsync(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CreateRewardAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.Reward> CreateRewardAsync(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_CreateReward, null, options, request);
      }
      public virtual global::Reward.Reward getReward(global::Common.RewardId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getReward(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Reward.Reward getReward(global::Common.RewardId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_getReward, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.Reward> getRewardAsync(global::Common.RewardId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getRewardAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.Reward> getRewardAsync(global::Common.RewardId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_getReward, null, options, request);
      }
      public virtual global::Common.ResponseStatus collectReward(global::Common.RewardId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return collectReward(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus collectReward(global::Common.RewardId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_collectReward, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> collectRewardAsync(global::Common.RewardId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return collectRewardAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> collectRewardAsync(global::Common.RewardId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_collectReward, null, options, request);
      }
      public virtual global::Reward.RewardList getAllRewardsByUser(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getAllRewardsByUser(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Reward.RewardList getAllRewardsByUser(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_getAllRewardsByUser, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.RewardList> getAllRewardsByUserAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getAllRewardsByUserAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Reward.RewardList> getAllRewardsByUserAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_getAllRewardsByUser, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override RewardServiceClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new RewardServiceClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(RewardServiceBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_CreateReward, serviceImpl.CreateReward)
          .AddMethod(__Method_getReward, serviceImpl.getReward)
          .AddMethod(__Method_collectReward, serviceImpl.collectReward)
          .AddMethod(__Method_getAllRewardsByUser, serviceImpl.getAllRewardsByUser).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, RewardServiceBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_CreateReward, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Battle.Battle, global::Reward.Reward>(serviceImpl.CreateReward));
      serviceBinder.AddMethod(__Method_getReward, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.RewardId, global::Reward.Reward>(serviceImpl.getReward));
      serviceBinder.AddMethod(__Method_collectReward, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.RewardId, global::Common.ResponseStatus>(serviceImpl.collectReward));
      serviceBinder.AddMethod(__Method_getAllRewardsByUser, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Reward.RewardList>(serviceImpl.getAllRewardsByUser));
    }

  }
}
#endregion
